<?php
/*
Plugin Name: TweetThis
Version: auto
Description: Add a "Tweet This" button on picture pages
Plugin URI: http://piwigo.org/ext/extension_view.php?eid=560
Author: Mistic
Author URI: http://www.strangeplanet.fr
*/

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

define('TWEET_PATH' , PHPWG_PLUGINS_PATH . basename(dirname(__FILE__)) . '/');

load_language('plugin.lang', TWEET_PATH);
add_event_handler('loc_end_picture', 'tweet_add_button');
add_event_handler('loc_end_index', 'tweet_add_button');


function tweet_add_button() 
{
  global $conf, $template;
  $conf['TweetThis'] = explode(',', $conf['TweetThis']);
  
  if (script_basename() == 'picture')
  {
    $template->assign(array(
      'TWEET_IMAGE' => $conf['TweetThis'][0],
      'TWEET_POSITON' => $conf['TweetThis'][1],
    ));
        
    $template->set_prefilter('picture', 'tweet_add_button_prefilter');
  }
  else if (script_basename() == 'index')
  {
    $template->assign(array(
      'TWEET_IMAGE' => $conf['TweetThis'][0],
      'TWEET_POSITON' => 'index',
    ));
        
    $template->set_prefilter('index', 'tweet_add_button_prefilter');
  }
  
  // html change a bit if we use custom button, or official with counter
  if ( in_array( $conf['TweetThis'][0], array('none','horizontal','vertical') ) )
  {
    $template->assign('TWEET_IFRAME', true);
    $template->assign('TWEET_COUNTER', $conf['TweetThis'][0]);
  }
  else
  {
    $template->assign('TWEET_IFRAME', false);
    $template->assign('TWEET_COUNTER', 'none');
  }
  
  // if the link is in the toolbar, we must use smallest buttons
  if ( script_basename() == 'index' OR  $conf['TweetThis'][1] == 'toolbar')
  {
    switch ($conf['TweetThis'][0])
    {
      case 'vertical':
        $template->assign('TWEET_COUNTER', 'horizontal'); break;
      case 't_logo-a':
        $template->assign('TWEET_IMAGE', 't_small-a'); break; 
      case 't_logo-b':
        $template->assign('TWEET_IMAGE', 't_small-b'); break; 
      case 't_logo-c':
        $template->assign('TWEET_IMAGE', 't_small-c'); break;
    }
  }
}

function tweet_add_button_prefilter($content, &$smarty)
{
  global $template;
  
  switch ($template->get_template_vars('TWEET_POSITON'))
  {
    case 'top':
      $search = '<div id="theImage">';
      $replace = '
<div><a href="javascript:phpWGOpenWindow(\'http://twitter.com/share?count={$TWEET_COUNTER}\', \'{\'Share on Twitter\'|@translate}\', \'scrollbars=yes,width=550,height=370\')" 
        class="{if $TWEET_IFRAME}twitter-share-button{/if}" title="{\'Share on Twitter\'|@translate}">
  {if $TWEET_IFRAME}Tweet{else}<img src="http://twitter-badges.s3.amazonaws.com/{$TWEET_IMAGE}.png"/>{/if}
</a></div>
';
      break;
      
    case 'bottom':
      $search = '{$ELEMENT_CONTENT}';
      $replace = '
<a href="javascript:phpWGOpenWindow(\'http://twitter.com/share?count={$TWEET_COUNTER}\', \'{\'Share on Twitter\'|@translate}\', \'scrollbars=yes,width=550,height=370\')" 
    class="{if $TWEET_IFRAME}twitter-share-button{/if}" title="{\'Share on Twitter\'|@translate}">
  {if $TWEET_IFRAME}Tweet{else}<img src="http://twitter-badges.s3.amazonaws.com/{$TWEET_IMAGE}.png"/>{/if}
</a>
';
      break;
      
    case 'toolbar':
      $search = '{*caddie management END*}';
      $replace = '
<a href="javascript:phpWGOpenWindow(\'http://twitter.com/share?count={$TWEET_COUNTER}\', \'{\'Share on Twitter\'|@translate}\', \'scrollbars=yes,width=550,height=370\')" 
    class="{if $TWEET_IFRAME}twitter-share-button{/if} pwg-button" title="{\'Share on Twitter\'|@translate}">
  {if $TWEET_IFRAME}Tweet{else}<img src="http://twitter-badges.s3.amazonaws.com/{$TWEET_IMAGE}.png"/>{/if}
</a>
';
      break;
      
    case 'index':  
      $search = '<ul class="categoryActions">';
      $replace = '
<li><a href="javascript:phpWGOpenWindow(\'http://twitter.com/share?count={$TWEET_COUNTER}\', \'{\'Share on Twitter\'|@translate}\', \'scrollbars=yes,width=550,height=370\')" 
        class="{if $TWEET_IFRAME}twitter-share-button{/if} pwg-button" title="{\'Share on Twitter\'|@translate}">
  {if $TWEET_IFRAME}Tweet{else}<img src="http://twitter-badges.s3.amazonaws.com/{$TWEET_IMAGE}.png"/>{/if}
</a></li>
';
      break;
  }
  
  $replace = $search . $replace . '{if $TWEET_IFRAME}{combine_script id=\'twitter_widgets\' path=\'http://platform.twitter.com/widgets.js}{/if}';

  return str_replace($search, $replace, $content);
}


if (script_basename() == 'admin')
{
  add_event_handler('get_admin_plugin_menu_links', 'tweet_plugin_admin_menu');

  function tweet_plugin_admin_menu($menu)
  {
    array_push(
      $menu,
      array(
        'NAME' => 'TweetThis',
        'URL' => get_root_url().'admin.php?page=plugin-'.basename(dirname(__FILE__))
        )
      );
    
    return $menu;
  }
}

?>